---
version: 2
jobs:
  test:
    machine:
      image: ubuntu-2004:202010-01
      docker_layer_caching: true
    steps:
    - checkout
    - run:
        name: Run YAML linting
        command: make lint
    - run:
        name: Validate Cloudformation templates
        command: make validate
    - run:
        name: Run unit tests
        command: make test

  build:
    machine:
      image: ubuntu-2004:202010-01
      docker_layer_caching: true
    steps:
    - checkout
    - run:
        name: Auth with ECR
        command: |
          make auth
          cat auth_token | docker login --username AWS --password-stdin 838080186947.dkr.ecr.ap-southeast-2.amazonaws.com
    - run:
        name: Build Docker image
        command: docker build -t 838080186947.dkr.ecr.ap-southeast-2.amazonaws.com/todo-app:pipeline.git.revision .
    - run:
        name: Push Docker image to ECR
        command: docker push 838080186947.dkr.ecr.ap-southeast-2.amazonaws.com/todo-app:pipeline.git.revision

  deploy:
    machine:
      image: ubuntu-2004:202010-01
      docker_layer_caching: true
    steps:
    - checkout
    - run:
        name: Deploy CloudFormation
        command: make deploy
        environment:
          ENV: test

  # build:
  #   working_directory: /go/src/github.com/servian/TechChallengeApp
  #   docker:
  #     - image: circleci/golang:latest

  #   steps:
  #     - checkout

  #     # build and test
  #     - run: go get -v -t -d ./...
  #     - run: go build -v
  #     - run: go test -v -race -cover ./...

  # deploy:
  #   working_directory: /go/src/github.com/servian/TechChallengeApp
  #   docker:
  #     - image: circleci/golang:latest

  #   steps:
  #     - checkout

  #     - run:
  #         name: Setup
  #         command: |
  #           go get -v -t -d ./...
  #           mkdir output
  #           go build -v -o TechChallengeApp .
  #           ls
  #           ./TechChallengeApp --version | sed -e 's/TechChallengeApp version /v./' > versionfile

  #     - run:
  #         name: Build for linux
  #         environment:
  #           GOOS: linux
  #           GOARCH: amd64
  #         command: |
  #           if [ -d "dist" ]; then
  #             rm -rf dist
  #           fi

  #           mkdir -p dist

  #           go build -v -o TechChallengeApp .

  #           cp TechChallengeApp dist/
  #           cp -r assets dist/
  #           cp conf.toml dist/
  #           rm TechChallengeApp

  #           export version=$(cat versionfile)

#           zip -r "output/TechChallengeApp_${version}_linux64.zip" dist/*

workflows:
  version: 2
  build_test_deploy:
    jobs:
    - test
    - build:
        requires:
        - test
        filters:
          branches:
            only: master
          tags:
            ignore: /.*/
    - deploy:
        requires:
        - build
        filters:
          branches:
            only: master
          tags:
            ignore: /.*/
